Index: squid/src/disk.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/disk.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/disk.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/disk.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,7 +1,6 @@
 
-
 /*
- * $Id: disk.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: disk.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 6     Disk I/O Routines
  * AUTHOR: Harvest Derived
@@ -36,113 +35,61 @@
 
 #include "squid.h"
 
-#define DISK_LINE_LEN  1024
-
-typedef struct open_ctrl_t {
-    FOCB *callback;
-    void *callback_data;
-    char *path;
-} open_ctrl_t;
-
-static AIOCB diskHandleWriteComplete;
-static AIOCB diskHandleReadComplete;
 static PF diskHandleRead;
 static PF diskHandleWrite;
-static AIOCB fileOpenComplete;
+
+#if defined(_SQUID_MSWIN_) || defined(_SQUID_OS2_)
+static int
+diskWriteIsComplete(int fd)
+{
+    return fd_table[fd].disk.write_q ? 0 : 1;
+}
+#endif
 
 void
 disk_init(void)
 {
-#if USE_ASYNC_IO
-    aioClose(dup(0));
-#endif
+    (void) 0;
 }
 
-/* Open a disk file. Return a file descriptor */
+/*
+ * opens a disk file specified by 'path'.  This function always
+ * blocks!  There is no callback.
+ */
 int
-file_open(const char *path, int mode, FOCB * callback, void *callback_data, void *tag)
+file_open(const char *path, int mode)
 {
     int fd;
-    open_ctrl_t *ctrlp;
-
-    ctrlp = xmalloc(sizeof(open_ctrl_t));
-    ctrlp->path = xstrdup(path);
-    ctrlp->callback = callback;
-    ctrlp->callback_data = callback_data;
-
     if (mode & O_WRONLY)
 	mode |= O_APPEND;
     mode |= SQUID_NONBLOCK;
-
-    /* Open file */
-    Opening_FD++;
-#if USE_ASYNC_IO
-    if (callback != NULL) {
-	aioOpen(path, mode, 0644, fileOpenComplete, ctrlp, tag);
-	return DISK_OK;
-    }
-#endif
     errno = 0;
     fd = open(path, mode, 0644);
-    fileOpenComplete(-1, ctrlp, fd, errno);
-    if (fd < 0)
-	return DISK_ERROR;
-    return fd;
-}
-
-
-static void
-fileOpenComplete(int unused, void *data, int fd, int errcode)
-{
-    open_ctrl_t *ctrlp = (open_ctrl_t *) data;
-    debug(6, 5) ("fileOpenComplete: FD %d, data %p, errcode %d\n",
-	fd, data, errcode);
     Counter.syscalls.disk.opens++;
-    Opening_FD--;
-    if (fd == -2 && errcode == -2) {	/* Cancelled - clean up */
-	if (ctrlp->callback)
-	    (ctrlp->callback) (ctrlp->callback_data, fd, errcode);
-	xfree(ctrlp->path);
-	xfree(ctrlp);
-	return;
-    }
     if (fd < 0) {
-	errno = errcode;
-	debug(50, 3) ("fileOpenComplete: error opening file %s: %s\n", ctrlp->path,
+	debug(50, 3) ("file_open: error opening file %s: %s\n", path,
 	    xstrerror());
-	if (ctrlp->callback)
-	    (ctrlp->callback) (ctrlp->callback_data, DISK_ERROR, errcode);
-	xfree(ctrlp->path);
-	xfree(ctrlp);
-	return;
+	fd = DISK_ERROR;
+    } else {
+	debug(6, 5) ("file_open: FD %d\n", fd);
+	commSetCloseOnExec(fd);
+	fd_open(fd, FD_FILE, path);
     }
-    debug(6, 5) ("fileOpenComplete: FD %d\n", fd);
-    commSetCloseOnExec(fd);
-    fd_open(fd, FD_FILE, ctrlp->path);
-    if (ctrlp->callback)
-	(ctrlp->callback) (ctrlp->callback_data, fd, errcode);
-    xfree(ctrlp->path);
-    xfree(ctrlp);
+    return fd;
 }
 
+
 /* close a disk file. */
 void
 file_close(int fd)
 {
     fde *F = &fd_table[fd];
-    PF *callback;
-#if USE_ASYNC_IO
-    if (fd < 0) {
-	debug(6, 0) ("file_close: FD less than zero: %d\n", fd);
-	return;
-    }
-#else
+    PF *read_callback;
     assert(fd >= 0);
-#endif
     assert(F->flags.open);
-    if ((callback = F->read_handler)) {
+    if ((read_callback = F->read_handler)) {
 	F->read_handler = NULL;
-	callback(-1, F->read_data);
+	read_callback(-1, F->read_data);
     }
     if (F->flags.write_daemon) {
 #if defined(_SQUID_MSWIN_) || defined(_SQUID_OS2_)
@@ -164,19 +111,13 @@
      */
     assert(F->write_handler == NULL);
     F->flags.closing = 1;
-#if USE_ASYNC_IO
-    aioClose(fd);
-#else
 #if CALL_FSYNC_BEFORE_CLOSE
     fsync(fd);
 #endif
     close(fd);
-#endif
     debug(6, F->flags.close_request ? 2 : 5)
 	("file_close: FD %d, really closing\n", fd);
-#if !USE_ASYNC_IO
     fd_close(fd);
-#endif
     Counter.syscalls.disk.closes++;
 }
 
@@ -230,83 +171,27 @@
 static void
 diskHandleWrite(int fd, void *notused)
 {
-#if !USE_ASYNC_IO
     int len = 0;
-#endif
     fde *F = &fd_table[fd];
     struct _fde_disk *fdd = &F->disk;
-    if (!fdd->write_q)
+    dwrite_q *q = fdd->write_q;
+    int status = DISK_OK;
+    int do_callback;
+    int do_close;
+    if (NULL == q)
 	return;
-#ifdef OPTIMISTIC_IO
-    assert(!F->flags.calling_io_handler);
-#endif
     debug(6, 3) ("diskHandleWrite: FD %d\n", fd);
+    F->flags.write_daemon = 0;
     assert(fdd->write_q != NULL);
     assert(fdd->write_q->len > fdd->write_q->buf_offset);
-#if USE_ASYNC_IO
-    aioWrite(fd,
-	-1,			/* seek offset, -1 == append */
-	fdd->write_q->buf + fdd->write_q->buf_offset,
-	fdd->write_q->len - fdd->write_q->buf_offset,
-	diskHandleWriteComplete,
-	fdd->write_q);
-#else
     debug(6, 3) ("diskHandleWrite: FD %d writing %d bytes\n",
 	fd, (int) (fdd->write_q->len - fdd->write_q->buf_offset));
     errno = 0;
     len = write(fd,
 	fdd->write_q->buf + fdd->write_q->buf_offset,
 	fdd->write_q->len - fdd->write_q->buf_offset);
-    diskHandleWriteComplete(fd, fdd->write_q, len, errno);
-#endif
-}
-
-static void
-diskHandleWriteComplete(int fd, void *data, int len, int errcode)
-{
-    fde *F = &fd_table[fd];
-    struct _fde_disk *fdd = &F->disk;
-    dwrite_q *q = fdd->write_q;
-    int status = DISK_OK;
-    int do_callback;
-    int do_close;
-    errno = errcode;
-    debug(6, 3) ("diskHandleWriteComplete: FD %d len = %d\n", fd, len);
+    debug(6, 3) ("diskHandleWrite: FD %d len = %d\n", fd, len);
     Counter.syscalls.disk.writes++;
-#if USE_ASYNC_IO
-/*
- * From:    "Michael O'Reilly" <michael@metal.iinet.net.au>
- * Date:    24 Feb 1998 15:12:06 +0800
- *
- * A small patch to improve the AIO sanity. the patch below makes sure
- * the write request really does match the data passed back from the
- * async IO call.  note that I haven't actually rebooted with this
- * patch yet, so 'provisional' is an understatement.
- */
-    if (q && q != data) {
-	dwrite_q *p = data;
-	debug(50, 0) ("KARMA: q != data (%p, %p)\n", q, p);
-	debug(50, 0) ("KARMA: (%d, %d, %d FD %d)\n",
-	    q->buf_offset, q->len, len, fd);
-	debug(50, 0) ("KARMA: desc %s, type %d, open %d, flags 0x%x\n",
-	    F->desc, F->type, F->flags.open, F->flags);
-	debug(50, 0) ("KARMA: (%d, %d)\n", p->buf_offset, p->len);
-	len = -1;
-	errcode = EFAULT;
-    }
-#endif
-    if (q == NULL)		/* Someone aborted then write completed */
-	return;
-
-    if (len == -2 && errcode == -2) {	/* Write cancelled - cleanup */
-	do {
-	    fdd->write_q = q->next;
-	    if (q->free_func)
-		(q->free_func) (q->buf);
-	    safe_free(q);
-	} while ((q = fdd->write_q));
-	return;
-    }
     fd_bytes(fd, len, FD_WRITE);
     if (len < 0) {
 	if (!ignoreErrno(errno)) {
@@ -360,7 +245,6 @@
     if (fdd->write_q == NULL) {
 	/* no more data */
 	fdd->write_q_tail = NULL;
-	F->flags.write_daemon = 0;
     } else {
 	/* another block is queued */
 	diskCombineWrites(fdd);
@@ -379,17 +263,11 @@
 	if (fdd->wrt_handle_data != NULL)
 	    cbdataUnlock(fdd->wrt_handle_data);
 	if (do_callback) {
-#ifdef OPTIMISTIC_IO
-	    F->flags.calling_io_handler = 1;
-#endif
 	    fdd->wrt_handle(fd, status, len, fdd->wrt_handle_data);
 	    /*
 	     * NOTE, this callback can close the FD, so we must
 	     * not touch 'F', 'fdd', etc. after this.
 	     */
-#ifdef OPTIMISTIC_IO
-	    F->flags.calling_io_handler = 0;
-#endif
 	    return;
 	}
     }
@@ -434,21 +312,7 @@
     }
     if (!F->flags.write_daemon) {
 	cbdataLock(F->disk.wrt_handle_data);
-#if USE_ASYNC_IO
 	diskHandleWrite(fd, NULL);
-#else
-#ifdef OPTIMISTIC_IO
-	if (F->flags.calling_io_handler)
-#endif
-	    commSetSelect(fd, COMM_SELECT_WRITE, diskHandleWrite, NULL, 0);
-#ifdef OPTIMISTIC_IO
-	else
-	    diskHandleWrite(fd, NULL);
-#endif
-#endif
-#ifndef OPTIMISTIC_IO
-	F->flags.write_daemon = 1;
-#endif
     }
 }
 
@@ -467,13 +331,9 @@
 diskHandleRead(int fd, void *data)
 {
     dread_ctrl *ctrl_dat = data;
-#if !USE_ASYNC_IO
     fde *F = &fd_table[fd];
     int len;
-#endif
-#ifdef OPTIMISTIC_IO
-    assert(!F->flags.calling_io_handler);
-#endif /* OPTIMISTIC_IO */
+    int rc = DISK_OK;
     /*
      * FD < 0 indicates premature close; we just have to free
      * the state data.
@@ -482,14 +342,6 @@
 	memFree(ctrl_dat, MEM_DREAD_CTRL);
 	return;
     }
-#if USE_ASYNC_IO
-    aioRead(fd,
-	ctrl_dat->offset,
-	ctrl_dat->buf,
-	ctrl_dat->req_len,
-	diskHandleReadComplete,
-	ctrl_dat);
-#else
     if (F->disk.offset != ctrl_dat->offset) {
 	debug(6, 3) ("diskHandleRead: FD %d seeking to offset %d\n",
 	    fd, (int) ctrl_dat->offset);
@@ -501,25 +353,7 @@
     len = read(fd, ctrl_dat->buf, ctrl_dat->req_len);
     if (len > 0)
 	F->disk.offset += len;
-    diskHandleReadComplete(fd, ctrl_dat, len, errno);
-#endif
-}
-
-static void
-diskHandleReadComplete(int fd, void *data, int len, int errcode)
-{
-    dread_ctrl *ctrl_dat = data;
-    int rc = DISK_OK;
-#ifdef OPTIMISTIC_IO
-    fde *F = &fd_table[fd];
-#endif /* OPTIMISTIC_IO */
     Counter.syscalls.disk.reads++;
-    errno = errcode;
-    if (len == -2 && errcode == -2) {	/* Read cancelled - cleanup */
-	cbdataUnlock(ctrl_dat->client_data);
-	memFree(ctrl_dat, MEM_DREAD_CTRL);
-	return;
-    }
     fd_bytes(fd, len, FD_READ);
     if (len < 0) {
 	if (ignoreErrno(errno)) {
@@ -532,14 +366,8 @@
     } else if (len == 0) {
 	rc = DISK_EOF;
     }
-#ifdef OPTIMISTIC_IO
-    F->flags.calling_io_handler = 1;
-#endif /* OPTIMISTIC_IO */
     if (cbdataValid(ctrl_dat->client_data))
 	ctrl_dat->handler(fd, ctrl_dat->buf, len, rc, ctrl_dat->client_data);
-#ifdef OPTIMISTIC_IO
-    F->flags.calling_io_handler = 0;
-#endif /* OPTIMISTIC_IO */
     cbdataUnlock(ctrl_dat->client_data);
     memFree(ctrl_dat, MEM_DREAD_CTRL);
 }
@@ -549,13 +377,10 @@
 /* buffer must be allocated from the caller. 
  * It must have at least req_len space in there. 
  * call handler when a reading is complete. */
-int
+void
 file_read(int fd, char *buf, int req_len, off_t offset, DRCB * handler, void *client_data)
 {
     dread_ctrl *ctrl_dat;
-#ifdef OPTIMISTIC_IO
-    fde *F = &fd_table[fd];
-#endif /* OPTIMISTIC_IO */
     assert(fd >= 0);
     ctrl_dat = memAllocate(MEM_DREAD_CTRL);
     ctrl_dat->fd = fd;
@@ -566,27 +391,5 @@
     ctrl_dat->handler = handler;
     ctrl_dat->client_data = client_data;
     cbdataLock(client_data);
-#if USE_ASYNC_IO
     diskHandleRead(fd, ctrl_dat);
-#else
-#ifndef OPTIMISTIC_IO
-    commSetSelect(fd,
-	COMM_SELECT_READ,
-	diskHandleRead,
-	ctrl_dat,
-	0);
-#else
-    if (F->flags.calling_io_handler)
-	commSetSelect(fd, COMM_SELECT_READ, diskHandleRead, ctrl_dat, 0);
-    else
-	diskHandleRead(fd, ctrl_dat);
-#endif /* OPTIMISTIC_IO */
-#endif
-    return DISK_OK;
-}
-
-int
-diskWriteIsComplete(int fd)
-{
-    return fd_table[fd].disk.write_q ? 0 : 1;
 }
Index: squid/src/dns.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/dns.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/dns.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: dns.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 34    Dnsserver interface
  * AUTHOR: Harvest Derived
@@ -37,6 +37,7 @@
 
 static helper *dnsservers = NULL;
 
+#if USE_DNSSERVERS
 static void
 dnsStats(StoreEntry * sentry)
 {
@@ -44,9 +45,12 @@
     helperStats(sentry, dnsservers);
 }
 
+#endif
+
 void
 dnsInit(void)
 {
+#if USE_DNSSERVERS
     static int init = 0;
     wordlist *w;
     if (!Config.Program.dnsserver)
@@ -68,8 +72,9 @@
 	cachemgrRegister("dns",
 	    "Dnsserver Statistics",
 	    dnsStats, 0, 1);
+	init = 1;
     }
-    init++;
+#endif
 }
 
 void
@@ -100,29 +105,30 @@
 variable_list *
 snmp_netDnsFn(variable_list * Var, snint * ErrP)
 {
-    variable_list *Answer;
+    variable_list *Answer = NULL;
     debug(49, 5) ("snmp_netDnsFn: Processing request:\n", Var->name[LEN_SQ_NET +
 	    1]);
     snmpDebugOid(5, Var->name, Var->name_length);
-    Answer = snmp_var_new(Var->name, Var->name_length);
     *ErrP = SNMP_ERR_NOERROR;
-    Answer->val_len = sizeof(snint);
-    Answer->val.integer = xmalloc(Answer->val_len);
-    Answer->type = SMI_COUNTER32;
     switch (Var->name[LEN_SQ_NET + 1]) {
     case DNS_REQ:
-	*(Answer->val.integer) = dnsservers->stats.requests;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    dnsservers->stats.requests,
+	    SMI_COUNTER32);
 	break;
     case DNS_REP:
-	*(Answer->val.integer) = dnsservers->stats.replies;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    dnsservers->stats.replies,
+	    SMI_COUNTER32);
 	break;
     case DNS_SERVERS:
-	*(Answer->val.integer) = dnsservers->n_running;
+	Answer = snmp_var_new_integer(Var->name, Var->name_length,
+	    dnsservers->n_running,
+	    SMI_COUNTER32);
 	break;
     default:
 	*ErrP = SNMP_ERR_NOSUCHNAME;
-	snmp_var_free(Answer);
-	return (NULL);
+	break;
     }
     return Answer;
 }
Index: squid/src/dns_internal.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dns_internal.c,v
retrieving revision 1.1
retrieving revision 1.1.1.1
diff -u -r1.1 -r1.1.1.1
--- squid/src/dns_internal.c	26 Jan 2000 03:25:01 -0000	1.1
+++ squid/src/dns_internal.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns_internal.c,v 1.1 2000/01/26 03:25:01 hno Exp $
+ * $Id: dns_internal.c,v 1.1.1.1 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 78    DNS lookups; interacts with lib/rfc1035.c
  * AUTHOR: Duane Wessels
Index: squid/src/dnsserver.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/dnsserver.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/dnsserver.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/dnsserver.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dnsserver.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: dnsserver.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 0     DNS Resolver
  * AUTHOR: Harvest Derived
@@ -266,6 +266,9 @@
 
 #if HAVE_RES_INIT
     res_init();
+#ifdef RES_DEFAULT
+    _res.options = RES_DEFAULT;
+#endif
 #ifdef RES_DEFNAMES
     _res.options &= ~RES_DEFNAMES;
 #endif
Index: squid/src/enums.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/enums.h,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/enums.h	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/enums.h	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: enums.h,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: enums.h,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -85,6 +85,7 @@
     ERR_FTP_FORBIDDEN,
     ERR_FTP_UNAVAILABLE,
     ERR_ONLY_IF_CACHED_MISS,	/* failure to satisfy only-if-cached request */
+    ERR_TOO_BIG,
     ERR_MAX
 } err_type;
 
@@ -101,6 +102,7 @@
     ACL_URLPATH_REGEX,
     ACL_URL_REGEX,
     ACL_URL_PORT,
+    ACL_MY_PORT,
 #if USE_IDENT
     ACL_IDENT,
 #endif
@@ -113,6 +115,7 @@
     ACL_SRC_ARP,
     ACL_SNMP_COMMUNITY,
     ACL_NETDB_SRC_RTT,
+    ACL_MAXCONN,
     ACL_ENUM_MAX
 } squid_acl;
 
@@ -245,6 +248,7 @@
     CC_MUST_REVALIDATE,
     CC_PROXY_REVALIDATE,
     CC_MAX_AGE,
+    CC_S_MAXAGE,
     CC_ONLY_IF_CACHED,
     CC_OTHER,
     CC_ENUM_END
@@ -289,7 +293,8 @@
     SOURCE_FASTEST,
     ROUNDROBIN_PARENT,
 #if USE_CACHE_DIGESTS
-    CACHE_DIGEST_HIT,
+    CD_PARENT_HIT,
+    CD_SIBLING_HIT,
 #endif
 #if USE_CARP
     CARP,
@@ -311,9 +316,9 @@
     ICP_DATAEND,
     ICP_SECHO,
     ICP_DECHO,
-    ICP_UNUSED12,
-    ICP_UNUSED13,
-    ICP_UNUSED14,
+    ICP_NOTIFY,
+    ICP_INVALIDATE,
+    ICP_DELETE,
     ICP_UNUSED15,
     ICP_UNUSED16,
     ICP_UNUSED17,
@@ -344,7 +349,6 @@
 
 enum {
     SWAPOUT_NONE,
-    SWAPOUT_OPENING,
     SWAPOUT_WRITING,
     SWAPOUT_DONE
 };
@@ -364,6 +368,15 @@
     METHOD_CONNECT,		/* 101 */
     METHOD_TRACE,		/* 110 */
     METHOD_PURGE,		/* 111 */
+    METHOD_OPTIONS,
+    METHOD_DELETE,		/* RFC2616 section 9.7 */
+    METHOD_PROPFIND,
+    METHOD_PROPPATCH,
+    METHOD_MKCOL,
+    METHOD_COPY,
+    METHOD_MOVE,
+    METHOD_LOCK,
+    METHOD_UNLOCK,
     METHOD_ENUM_END
 };
 typedef unsigned int method_t;
@@ -390,6 +403,7 @@
     HTTP_STATUS_NONE = 0,
     HTTP_CONTINUE = 100,
     HTTP_SWITCHING_PROTOCOLS = 101,
+    HTTP_PROCESSING = 102,	/* RFC2518 section 10.1 */
     HTTP_OK = 200,
     HTTP_CREATED = 201,
     HTTP_ACCEPTED = 202,
@@ -397,6 +411,7 @@
     HTTP_NO_CONTENT = 204,
     HTTP_RESET_CONTENT = 205,
     HTTP_PARTIAL_CONTENT = 206,
+    HTTP_MULTI_STATUS = 207,	/* RFC2518 section 10.2 */
     HTTP_MULTIPLE_CHOICES = 300,
     HTTP_MOVED_PERMANENTLY = 301,
     HTTP_MOVED_TEMPORARILY = 302,
@@ -419,12 +434,16 @@
     HTTP_REQUEST_ENTITY_TOO_LARGE = 413,
     HTTP_REQUEST_URI_TOO_LARGE = 414,
     HTTP_UNSUPPORTED_MEDIA_TYPE = 415,
+    HTTP_UNPROCESSABLE_ENTITY = 422,	/* RFC2518 section 10.3 */
+    HTTP_LOCKED = 423,		/* RFC2518 section 10.4 */
+    HTTP_FAILED_DEPENDENCY = 424,	/* RFC2518 section 10.5 */
     HTTP_INTERNAL_SERVER_ERROR = 500,
     HTTP_NOT_IMPLEMENTED = 501,
     HTTP_BAD_GATEWAY = 502,
     HTTP_SERVICE_UNAVAILABLE = 503,
     HTTP_GATEWAY_TIMEOUT = 504,
     HTTP_HTTP_VERSION_NOT_SUPPORTED = 505,
+    HTTP_INSUFFICIENT_STORAGE = 507,	/* RFC2518 section 10.6 */
     HTTP_INVALID_HEADER = 600	/* Squid header parsing error */
 } http_status;
 
@@ -447,7 +466,8 @@
     ENTRY_NEGCACHED,
     ENTRY_VALIDATED,
     ENTRY_BAD_LENGTH,
-    ENTRY_ABORTED
+    ENTRY_ABORTED,
+    ENTRY_DONT_LOG		/* hack for gross 'Pump' entries */
 };
 
 typedef enum {
@@ -516,6 +536,10 @@
     MEM_HELPER_REQUEST,
     MEM_HELPER_SERVER,
     MEM_HIERARCHYLOGENTRY,
+#if USE_HTCP
+    MEM_HTCP_SPECIFIER,
+    MEM_HTCP_DETAIL,
+#endif
     MEM_HTTP_HDR_CC,
     MEM_HTTP_HDR_CONTENT_RANGE,
     MEM_HTTP_HDR_ENTRY,
@@ -555,6 +579,11 @@
     MEM_SWAPDIR,
     MEM_USHORTLIST,
     MEM_WORDLIST,
+    MEM_STORE_IO,
+#if !USE_DNSSERVERS
+    MEM_IDNS_QUERY,
+#endif
+    MEM_EVENT,
     MEM_MAX
 } mem_type;
 
@@ -622,3 +651,9 @@
     NETDB_EX_RTT,
     NETDB_EX_HOPS
 };
+
+typedef enum {
+    SWAPDIR_UFS,
+    SWAPDIR_ASYNCUFS,
+    SWAPDIR_MAX
+} swapdir_t;
Index: squid/src/errorpage.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/errorpage.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/errorpage.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/errorpage.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: errorpage.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: errorpage.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 4     Error Generation
  * AUTHOR: Duane Wessels
@@ -67,7 +67,7 @@
 	ERR_SQUID_SIGNATURE,
 	    "\n<br clear=\"all\">\n"
 	    "<hr noshade size=1>\n"
-	    "Generated %T by %h (<a href=\"http://squid.nlanr.net/Squid/\">%s</a>)\n"
+	    "Generated %T by %h (%s)\n"
 	    "</BODY></HTML>\n"
     }
 };
@@ -171,7 +171,7 @@
     char *text;
 
     snprintf(path, sizeof(path), "%s/%s", dir, page_name);
-    fd = file_open(path, O_RDONLY, NULL, NULL, NULL);
+    fd = file_open(path, O_RDONLY);
     if (fd < 0 || fstat(fd, &sb) < 0) {
 	debug(4, 0) ("errorTryLoadText: '%s': %s\n", path, xstrerror());
 	if (fd >= 0)
@@ -378,6 +378,9 @@
     safe_free(err->host);
     safe_free(err->dnsserver_msg);
     safe_free(err->request_hdrs);
+    wordlistDestroy(&err->ftp.server_msg);
+    safe_free(err->ftp.request);
+    safe_free(err->ftp.reply);
     if (err->flags.flag_cbdata)
 	cbdataFree(err);
     else
@@ -451,7 +454,7 @@
 	break;
     case 'g':
 	/* FTP SERVER MESSAGE */
-	wordlistCat(err->ftp_server_msg, &mb);
+	wordlistCat(err->ftp.server_msg, &mb);
 	break;
     case 'h':
 	memBufPrintf(&mb, "%s", getMyHostname());
Index: squid/src/event.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/event.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/event.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/event.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: event.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: event.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 41    Event Processing
  * AUTHOR: Henrik Nordstrom
@@ -49,11 +49,12 @@
 static struct ev_entry *tasks = NULL;
 static OBJH eventDump;
 static int run_id = 0;
+static const char *last_event_ran = NULL;
 
 void
 eventAdd(const char *name, EVH * func, void *arg, double when, int weight)
 {
-    struct ev_entry *event = xcalloc(1, sizeof(struct ev_entry));
+    struct ev_entry *event = memAllocate(MEM_EVENT);
     struct ev_entry **E;
     event->func = func;
     event->arg = arg;
@@ -101,7 +102,7 @@
 	*E = event->next;
 	if (NULL != event->arg)
 	    cbdataUnlock(event->arg);
-	xfree(event);
+	memFree(event, MEM_EVENT);
 	return;
     }
     debug_trap("eventDelete: event not found");
@@ -121,6 +122,7 @@
     run_id++;
     debug(41, 5) ("eventRun: RUN ID %d\n", run_id);
     while ((event = tasks)) {
+	int valid = 1;
 	if (event->when > current_dtime)
 	    break;
 	if (event->id == run_id)	/* was added during this run */
@@ -133,17 +135,18 @@
 	event->arg = NULL;
 	tasks = event->next;
 	if (NULL != arg) {
-	    int valid = cbdataValid(arg);
+	    valid = cbdataValid(arg);
 	    cbdataUnlock(arg);
-	    if (!valid) {
-		safe_free(event);
-		return;
-	    }
 	}
-	weight += event->weight;
-	debug(41, 5) ("eventRun: Running '%s', id %d\n", event->name, event->id);
-	func(arg);
-	safe_free(event);
+	if (valid) {
+	    weight += event->weight;
+	    /* XXX assumes ->name is static memory! */
+	    last_event_ran = event->name;
+	    debug(41, 5) ("eventRun: Running '%s', id %d\n",
+		event->name, event->id);
+	    func(arg);
+	}
+	memFree(event, MEM_EVENT);
     }
 }
 
@@ -158,6 +161,7 @@
 void
 eventInit(void)
 {
+    memDataInit(MEM_EVENT, "event", sizeof(struct ev_entry), 0);
     cachemgrRegister("events",
 	"Event Queue",
 	eventDump, 0, 1);
@@ -167,12 +171,17 @@
 eventDump(StoreEntry * sentry)
 {
     struct ev_entry *e = tasks;
-    storeAppendPrintf(sentry, "%s\t%s\n",
+    if (last_event_ran)
+	storeAppendPrintf(sentry, "Last event to run: %s\n\n", last_event_ran);
+    storeAppendPrintf(sentry, "%s\t%s\t%s\t%s\n",
 	"Operation",
-	"Next Execution");
+	"Next Execution",
+	"Weight",
+	"Callback Valid?");
     while (e != NULL) {
-	storeAppendPrintf(sentry, "%s\t%f seconds\n",
-	    e->name, e->when - current_dtime);
+	storeAppendPrintf(sentry, "%s\t%f seconds\t%d\t%s\n",
+	    e->name, e->when - current_dtime, e->weight,
+	    e->arg ? cbdataValid(e->arg) ? "yes" : "no" : "N/A");
 	e = e->next;
     }
 }
@@ -184,7 +193,7 @@
     while ((event = tasks)) {
 	if (NULL != event->arg)
 	    cbdataUnlock(event->arg);
-	xfree(event);
+	memFree(event, MEM_EVENT);
     }
     tasks = NULL;
 }
Index: squid/src/fd.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fd.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.3
diff -u -r1.1.1.2 -r1.1.1.3
--- squid/src/fd.c	26 Jan 2000 03:23:10 -0000	1.1.1.2
+++ squid/src/fd.c	26 Jan 2000 03:25:01 -0000	1.1.1.3
@@ -1,6 +1,6 @@
 
 /*
- * $Id: fd.c,v 1.1.1.2 2000/01/26 03:23:10 hno Exp $
+ * $Id: fd.c,v 1.1.1.3 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 51    Filedescriptor Functions
  * AUTHOR: Duane Wessels
@@ -90,16 +90,6 @@
     F->timeout = 0;
 }
 
-#if USE_ASYNC_IO
-void
-fd_was_closed(int fd)
-{
-    fde *F = &fd_table[fd];
-    if (F->flags.closing)
-	fd_close(fd);
-}
-#endif
-
 void
 fd_open(int fd, unsigned int type, const char *desc)
 {
Index: squid/src/filemap.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/filemap.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/src/filemap.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/src/filemap.c	26 Jan 2000 03:25:01 -0000	1.1.1.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: filemap.c,v 1.1.1.1 2000/01/26 03:21:47 hno Exp $
+ * $Id: filemap.c,v 1.1.1.2 2000/01/26 03:25:01 hno Exp $
  *
  * DEBUG: section 8     Swap File Bitmap
  * AUTHOR: Harvest Derived
@@ -53,35 +53,47 @@
 #define ALL_ONES (unsigned long) 0xFFFFFFFF
 #endif
 
+#define FM_INITIAL_NUMBER (1<<14)
+
 fileMap *
-file_map_create(int n)
+file_map_create(void)
 {
     fileMap *fm = xcalloc(1, sizeof(fileMap));
-    fm->max_n_files = n;
-    fm->nwords = n >> LONG_BIT_SHIFT;
-    debug(8, 3) ("file_map_create: creating space for %d files\n", n);
+    fm->max_n_files = FM_INITIAL_NUMBER;
+    fm->nwords = fm->max_n_files >> LONG_BIT_SHIFT;
+    debug(8, 3) ("file_map_create: creating space for %d files\n", fm->max_n_files);
     debug(8, 5) ("--> %d words of %d bytes each\n",
-	fm->nwords, sizeof(unsigned long));
-    fm->file_map = xcalloc(fm->nwords, sizeof(unsigned long));
+	fm->nwords, sizeof(*fm->file_map));
+    fm->file_map = xcalloc(fm->nwords, sizeof(*fm->file_map));
     /* XXX account fm->file_map */
     return fm;
 }
 
+static void
+file_map_grow(fileMap * fm)
+{
+    int old_sz = fm->nwords * sizeof(*fm->file_map);
+    void *old_map = fm->file_map;
+    fm->max_n_files <<= 1;
+    assert(fm->max_n_files <= (1 << 30));
+    fm->nwords = fm->max_n_files >> LONG_BIT_SHIFT;
+    debug(8, 3) ("file_map_grow: creating space for %d files\n", fm->max_n_files);
+    fm->file_map = xcalloc(fm->nwords, sizeof(*fm->file_map));
+    debug(8, 3) ("copying %d old bytes\n", old_sz);
+    xmemcpy(fm->file_map, old_map, old_sz);
+    xfree(old_map);
+    /* XXX account fm->file_map */
+}
+
 int
 file_map_bit_set(fileMap * fm, int file_number)
 {
     unsigned long bitmask = (1L << (file_number & LONG_BIT_MASK));
+    while (file_number >= fm->max_n_files)
+	file_map_grow(fm);
     fm->file_map[file_number >> LONG_BIT_SHIFT] |= bitmask;
     fm->n_files_in_map++;
-    if (!fm->toggle && (fm->n_files_in_map > ((fm->max_n_files * 7) >> 3))) {
-	fm->toggle++;
-	debug(8, 0) ("WARNING: filemap utilization at %d%%\n"
-	    "\tConsider decreasing store_avg_object_size in squid.conf\n",
-	    percent(fm->n_files_in_map, fm->max_n_files));
-    } else if (fm->n_files_in_map == fm->max_n_files) {
-	fatal_dump("You've run out of swap file numbers.");
-    }
-    return (file_number);
+    return file_number;
 }
 
 void
@@ -96,6 +108,8 @@
 file_map_bit_test(fileMap * fm, int file_number)
 {
     unsigned long bitmask = (1L << (file_number & LONG_BIT_MASK));
+    if (file_number >= fm->max_n_files)
+	return 0;
     /* be sure the return value is an int, not a u_long */
     return (fm->file_map[file_number >> LONG_BIT_SHIFT] & bitmask ? 1 : 0);
 }
@@ -106,7 +120,7 @@
     int word;
     int bit;
     int count;
-    if (suggestion > fm->max_n_files)
+    if (suggestion >= fm->max_n_files)
 	suggestion = 0;
     if (!file_map_bit_test(fm, suggestion)) {
 	return file_map_bit_set(fm, suggestion);
@@ -123,8 +137,9 @@
 	    return file_map_bit_set(fm, suggestion);
 	}
     }
-    fatal("file_map_allocate: Exceeded filemap limit");
-    return 0;			/* NOTREACHED */
+    debug(8, 3) ("growing from file_map_allocate\n");
+    file_map_grow(fm);
+    return file_map_allocate(fm, fm->max_n_files >> 1);
 }
 
 void
@@ -134,15 +149,6 @@
     safe_free(fm);
 }
 
-void
-filemapCopy(fileMap * old, fileMap * new)
-{
-    assert(old->max_n_files <= new->max_n_files);
-    assert(0 == new->n_files_in_map);
-    xmemcpy(new->file_map, old->file_map, old->nwords * sizeof(unsigned long));
-    new->n_files_in_map = old->n_files_in_map;
-}
-
 #ifdef TEST
 
 #define TEST_SIZE 1<<16
